## kid3 3.7.1

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -DCMAKE_BUILD_TYPE=Release -DWITH_APPS=Qt -DCMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ../kid3
# make
# cpack

project(kid3)

cmake_minimum_required(VERSION 3.3)

set(BUILD_SHARED_LIBS ON CACHE BOOL "build shared libraries")
set(WITH_QML    ON CACHE BOOL "build with QML")
set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_FFMPEG OFF CACHE BOOL "force use of FFmpeg for Chromaprint decoding")
set(WITH_CHROMAPRINT_FFMPEG OFF CACHE BOOL "link FFmpeg only for Chromaprint FFT")
set(WITH_GSTREAMER OFF CACHE BOOL "force use of GStreamer for Chromaprint decoding")
set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
set(WITH_NO_MANCOMPRESS OFF CACHE BOOL "disable compressed manpages")
if(ANDROID)
  set(CMAKE_INSTALL_PREFIX "" CACHE PATH "install path prefix" FORCE)
  set(WITH_ID3LIB OFF CACHE BOOL "build with id3lib")
  set(WITH_VORBIS OFF CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC OFF CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT OFF CACHE BOOL "build with Chromaprint")
else()
  set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
  set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC ON CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
endif()
if(APPLE OR WIN32)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
elseif(ANDROID)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qml" CACHE STRING "build applications (Qml;Qt;CLI;Test)")
else()
  set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI;KDE" CACHE STRING "build applications (Qt;CLI;KDE;Test)")
endif()
if(WIN32)
  set(WITH_READLINE OFF CACHE BOOL "build with readline")
else()
  set(WITH_READLINE ON CACHE BOOL "build with readline")
endif()

if(DEFINED WITH_KDE)
  unset(WITH_KDE CACHE)
  message(FATAL_ERROR "The variable WITH_KDE is no longer used. The KDE and Qt "
                      "applications can now be built together using common "
                      "libraries. Use WITH_APPS with a value of \"KDE\" for "
                      "the KDE application, \"Qt\" for the Qt application, "
                      "\"CLI\" for the command line application or "
                      "\"Qt;CLI;KDE\" for all. Default is -DWITH_APPS="
                      "\"${WITH_APPS}\".")
endif()

if(WITH_APPS)
  string(TOLOWER "${WITH_APPS}" _apps_lower)
  foreach(_app ${_apps_lower})
    if(_app STREQUAL "qt")
      set(BUILD_QT_APP ON)
    elseif(_app STREQUAL "qml")
      set(BUILD_QML_APP ON)
      set(WITH_QML ON)
    elseif(_app STREQUAL "cli")
      set(BUILD_CLI_APP ON)
    elseif(_app STREQUAL "kde")
      set(BUILD_KDE_APP ON)
    elseif(_app STREQUAL "test")
      set(BUILD_TEST_APP ON)
    else()
      message(SEND_ERROR "Invalid value ${_app} in WITH_APPS. "
                         "Supported applications are \"Qt;KDE;Test\".")
    endif()
  endforeach()
endif()

if(NOT BUILD_SHARED_LIBS AND WITH_QML)
  message(WARNING "Switching off WITH_QML because of static build")
  set(WITH_QML OFF)
  set(BUILD_QML_APP OFF)
endif()


# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 7)
set(CPACK_PACKAGE_VERSION_PATCH 1)
set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
#set(CPACK_PACKAGE_VERSION "git20190310")
set(RELEASE_YEAR 2019)

# Platform specific default installation paths
if(APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_QMLDIR_DEFAULT "kid3.app/Contents/Resources/qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT "kid3.app/Contents/MacOS")
  set(WITH_PLUGINSDIR_DEFAULT "kid3.app/Contents/PlugIns")
elseif(WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_QMLDIR_DEFAULT "./qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT "./plugins")
elseif(ANDROID)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ":/translations")
  set(WITH_QMLDIR_DEFAULT ":/")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT ".")
  set(QT_ANDROID_APP_VERSION ${KID3_VERSION})
  set(QT_ANDROID_APP_VERSION_CODE 15)
else()
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  if(BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3/translations")
  else()
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  endif()
  set(WITH_QMLDIR_DEFAULT "share/kid3/qml")
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib${LIB_SUFFIX}/kid3")
  set(WITH_PLUGINSDIR_DEFAULT "${WITH_LIBDIR_DEFAULT}/plugins")
endif()

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
if(BUILD_KDE_APP)
  set(WITH_DBUSDIR "share/dbus-1/interfaces" CACHE STRING
      "dbus directory relative to CMAKE_INSTALL_PREFIX")
endif()
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_PLUGINSDIR ${WITH_PLUGINSDIR_DEFAULT} CACHE STRING
    "plugin directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_MANDIR ${WITH_DATAROOTDIR}/man CACHE STRING
    "man documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_QMLDIR ${WITH_QMLDIR_DEFAULT} CACHE STRING
    "QML directory relative to CMAKE_INSTALL_PREFIX")
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else()
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif()

if(APPLE)
  file(RELATIVE_PATH CFG_DATAROOTDIR "/kid3.app/Contents/MacOS" /${WITH_DATAROOTDIR})
  file(RELATIVE_PATH CFG_DOCDIR "/kid3.app/Contents/MacOS" /${WITH_DOCDIR})
  file(RELATIVE_PATH CFG_TRANSLATIONSDIR "/kid3.app/Contents/MacOS" /${WITH_TRANSLATIONSDIR})
  file(RELATIVE_PATH CFG_QMLDIR "/kid3.app/Contents/MacOS" /${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR "/kid3.app/Contents/MacOS" /${WITH_PLUGINSDIR})
else()
  set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
  set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
  set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
  set(CFG_QMLDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR /${WITH_BINDIR} /${WITH_PLUGINSDIR})
endif()
if(CFG_PLUGINSDIR STREQUAL "")
  set(CFG_PLUGINSDIR ".")
endif()
if(WITH_QMLDIR MATCHES "^:/")
  set(HAVE_QMLDIR_IN_QRC 1)
endif()
if(WITH_TRANSLATIONSDIR MATCHES "^:/")
  set(HAVE_TRANSLATIONSDIR_IN_QRC 1)
endif()
set(CFG_QMLSRCDIR "${kid3_SOURCE_DIR}/src/qml")

find_package(Threads)
find_package(PythonInterp REQUIRED)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

# Find Qt
set(_qt5Dir)
string(REGEX MATCH "^(.*[Qq]t[/\\]?5.*).bin.qmake.*" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
if(_qt5Dir)
  set(_qt5Dir ${CMAKE_MATCH_1})
endif()

if(_qt5Dir)
  set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
  find_package(Qt5Core)
  if(Qt5Core_FOUND)
    message(STATUS "Qt5Core found in ${_qt5Dir}")
    set(Qt5_DIR "${_qt5Dir}/lib/cmake/Qt5")
    set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
    set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
    set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
    set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
    set(Qt5Multimedia_DIR "${_qt5Dir}/lib/cmake/Qt5Multimedia")
    set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
    set(Qt5Test_DIR "${_qt5Dir}/lib/cmake/Qt5Test")
    if(WITH_DBUS)
      set(Qt5DBus_DIR "${_qt5Dir}/lib/cmake/Qt5DBus")
    endif()
    if(WITH_QML)
      set(Qt5Qml_DIR "${_qt5Dir}/lib/cmake/Qt5Qml")
      set(Qt5Quick_DIR "${_qt5Dir}/lib/cmake/Qt5Quick")
    endif()
    if(BUILD_QML_APP)
      set(Qt5Svg_DIR "${_qt5Dir}/lib/cmake/Qt5Svg")
      set(Qt5QuickControls2_DIR "${_qt5Dir}/lib/cmake/Qt5QuickControls2")
    endif()
    if(ANDROID)
      set(Qt5AndroidExtras_DIR "${_qt5Dir}/lib/cmake/Qt5AndroidExtras")
    endif()
  endif()
else()
  find_package(Qt5Core)
endif()
if(Qt5Core_FOUND)
  set(_qtComponents Core Gui Widgets Network Xml Multimedia LinguistTools Test)
  if(WITH_DBUS)
    set(_qtComponents ${_qtComponents} DBus)
  endif()
  if(WITH_QML)
    set(_qtComponents ${_qtComponents} Qml Quick)
  endif()
  if(BUILD_QML_APP)
    set(_qtComponents ${_qtComponents} Svg QuickControls2)
  endif()
  if(ANDROID)
    set(_qtComponents ${_qtComponents} AndroidExtras)
  endif()
  find_package(Qt5 COMPONENTS ${_qtComponents} REQUIRED)

  if(WITH_DBUS)
    set(HAVE_QTDBUS 1)
  endif()
  get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
  get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)
  if(APPLE)
    # For Mac Qt5.5.0 QT_LIBRARY_DIR is wrong
    # (<installdir>/Qt5.5.0/5.5/clang_64/lib/QtCore.framework), fix it.
    string(REGEX MATCH "^(.*)/QtCore.framework$" _qt5LibDir "${QT_LIBRARY_DIR}")
    if(_qt5LibDir)
      set(QT_LIBRARY_DIR ${CMAKE_MATCH_1})
    endif()
  endif()
  if(TARGET Qt5::lupdate)
    get_target_property(QT_LUPDATE_EXECUTABLE Qt5::lupdate LOCATION)
  endif()
  if(TARGET Qt5::QJpegPlugin)
    get_target_property(QT_PLUGINS_DIR Qt5::QJpegPlugin LOCATION)
  endif()
  if(QT_PLUGINS_DIR)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
  elseif(_qt5Dir)
    set(QT_PLUGINS_DIR ${_qt5Dir}/plugins)
  else()
    # Before Qt 5.2, there seems to be no way to get the plugins directory.
    # Assume it is on the same level as the bin directory.
    get_filename_component(QT_PLUGINS_DIR ${QT_LUPDATE_EXECUTABLE} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    set(QT_PLUGINS_DIR ${QT_PLUGINS_DIR}/plugins)
  endif()

  get_target_property(_qmakeLocation Qt5::qmake LOCATION)
  message(STATUS "Found Qt-Version ${Qt5Core_VERSION_STRING} (using ${_qmakeLocation})")
endif()

if(NOT Qt5Core_FOUND)
  message(FATAL_ERROR "Qt5 not found.")
endif()

if(LINUX_SELF_CONTAINED)
  set(CPACK_INSTALL_PREFIX "")
  # Avoid GLIBC_2.14 not found errors on older systems like Debian Wheezy.
  # http://stackoverflow.com/questions/8823267/linking-against-older-symbol-version-in-a-so-file
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  # Use RPATH instead of RUNPATH, the RPATH of the loading executable has to be used, see
  # http://blog.qt.io/blog/2011/10/28/rpath-and-runpath/
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--disable-new-dtags")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

# Check that QT_NO_DEBUG is defined for release configurations

=== android/CMakeLists.txt ===
include(qt-android-cmake/AddQtAndroidApk.cmake)
set(QT_ANDROID_APP_PACKAGE_NAME "net.sourceforge.kid3")
set(QT_ANDROID_APP_NAME "Kid3")
set(QT_ANDROID_BUILD_TOOLS_REVISION "23.0.1")
set(_androidPackageDir ${CMAKE_CURRENT_BINARY_DIR}/package)
configure_file(AndroidManifest.xml.in
               ${_androidPackageDir}/AndroidManifest.xml @ONLY)
add_custom_command(OUTPUT ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_androidPackageDir}/src/net/sourceforge/kid3
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Activity.java
          ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/Kid3Activity.java
)               
add_custom_command(OUTPUT ${_androidPackageDir}/res/drawable/icon.png
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_androidPackageDir}/res/drawable
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/../src/app/48-apps-kid3.png
          ${_androidPackageDir}/res/drawable/icon.png
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../src/app/48-apps-kid3.png
)
add_custom_target(android-package
  DEPENDS ${_androidPackageDir}/res/drawable/icon.png
          ${_androidPackageDir}/src/net/sourceforge/kid3/Kid3Activity.java)
if(CMAKE_BUILD_TYPE STREQUAL "Release" AND ANDROID_KEYSTORE_PATH AND ANDROID_KEYSTORE_ALIAS)
  set(_keystorePathAlias ${ANDROID_KEYSTORE_PATH} ${ANDROID_KEYSTORE_ALIAS})
else()
  set(_keystorePathAlias)
endif()
add_qt_android_apk(apk kid3-qml
  NAME Kid3
  PACKAGE_NAME "net.sourceforge.kid3"
  DEPENDS kid3-core kid3-gui
          musicbrainzimport discogsimport freedbimport amazonimport
          taglibmetadata kid3qml Qt5::Svg
          ${ANDROID_EXTRA_LIBS_DIR}/libssl.so ${ANDROID_EXTRA_LIBS_DIR}/libcrypto.so
  DEPLOYMENT_DEPENDS jar/QtAndroid-bundled.jar jar/QtAndroidBearer-bundled.jar jar/QtMultimedia-bundled.jar
    lib/libQt5Core.so lib/libQt5Xml.so lib/libQt5Network.so lib/libQt5Gui.so
    plugins/bearer/libqandroidbearer.so plugins/platforms/android/libqtforandroid.so plugins/iconengines/libqsvgicon.so
#    plugins/imageformats/libqdds.so plugins/imageformats/libqgif.so plugins/imageformats/libqicns.so plugins/imageformats/libqico.so plugins/imageformats/libqjp2.so
    plugins/imageformats/libqjpeg.so
#    plugins/imageformats/libqmng.so
    plugins/imageformats/libqsvg.so
#    plugins/imageformats/libqtga.so plugins/imageformats/libqtiff.so plugins/imageformats/libqwbmp.so plugins/imageformats/libqwebp.so
    lib/libQt5Multimedia.so lib/libQt5Qml.so
#    plugins/qmltooling/libqmldbg_qtquick2.so plugins/qmltooling/libqmldbg_tcp.so
    lib/libQt5Quick.so lib/libQt5Widgets.so lib/libQt5Svg.so
    lib/libQt5QuickControls2.so lib/libQt5QuickTemplates2.so lib/libQt5AndroidExtras.so
#    lib/libQt5MultimediaQuick_p.so plugins/mediaservice/libqtmedia_android.so plugins/audio/libqtaudio_opensles.so plugins/video/videonode/libqtsgvideonode_android.so plugins/playlistformats/libqtmultimedia_m3u.so
#    qml/Enginio/libenginioplugin.so qml/Enginio/plugins.qmltypes qml/Enginio/qmldir
    qml/Qt/labs/folderlistmodel/libqmlfolderlistmodelplugin.so qml/Qt/labs/folderlistmodel/plugins.qmltypes qml/Qt/labs/folderlistmodel/qmldir
#    qml/Qt/labs/settings/libqmlsettingsplugin.so qml/Qt/labs/settings/plugins.qmltypes qml/Qt/labs/settings/qmldir
#    qml/Qt/WebSockets/qmldir
#    qml/Qt3D/Input/libquick3dinputplugin.so qml/Qt3D/Input/qmldir qml/Qt3D/libquick3dcoreplugin.so qml/Qt3D/qmldir qml/Qt3D/Renderer/libquick3drendererplugin.so qml/Qt3D/Renderer/qmldir
#    qml/QtBluetooth/libdeclarative_bluetooth.so qml/QtBluetooth/plugins.qmltypes qml/QtBluetooth/qmldir
#    qml/QtCanvas3D/designer/default/Canvas3D.qml qml/QtCanvas3D/designer/images/canvas3d-icon.png qml/QtCanvas3D/designer/images/canvas3d-icon16.png qml/QtCanvas3D/designer/qtcanvas3d.metainfo qml/QtCanvas3D/libqtcanvas3d.so qml/QtCanvas3D/plugins.qmltypes qml/QtCanvas3D/qmldir
#    qml/QtGraphicalEffects/Blend.qml qml/QtGraphicalEffects/BrightnessContrast.qml qml/QtGraphicalEffects/Colorize.qml qml/QtGraphicalEffects/ColorOverlay.qml qml/QtGraphicalEffects/ConicalGradient.qml qml/QtGraphicalEffects/Desaturate.qml qml/QtGraphicalEffects/DirectionalBlur.qml qml/QtGraphicalEffects/Displace.qml qml/QtGraphicalEffects/DropShadow.qml qml/QtGraphicalEffects/FastBlur.qml qml/QtGraphicalEffects/GammaAdjust.qml qml/QtGraphicalEffects/GaussianBlur.qml qml/QtGraphicalEffects/Glow.qml qml/QtGraphicalEffects/HueSaturation.qml qml/QtGraphicalEffects/InnerShadow.qml qml/QtGraphicalEffects/LevelAdjust.qml qml/QtGraphicalEffects/LinearGradient.qml qml/QtGraphicalEffects/MaskedBlur.qml qml/QtGraphicalEffects/OpacityMask.qml qml/QtGraphicalEffects/private/FastGlow.qml qml/QtGraphicalEffects/private/FastInnerShadow.qml qml/QtGraphicalEffects/private/FastMaskedBlur.qml qml/QtGraphicalEffects/private/GaussianDirectionalBlur.qml qml/QtGraphicalEffects/private/GaussianGlow.qml qml/QtGraphicalEffects/private/GaussianInnerShadow.qml qml/QtGraphicalEffects/private/GaussianMaskedBlur.qml qml/QtGraphicalEffects/private/SourceProxy.qml qml/QtGraphicalEffects/qmldir qml/QtGraphicalEffects/RadialBlur.qml qml/QtGraphicalEffects/RadialGradient.qml qml/QtGraphicalEffects/RectangularGlow.qml qml/QtGraphicalEffects/RecursiveBlur.qml qml/QtGraphicalEffects/ThresholdMask.qml qml/QtGraphicalEffects/ZoomBlur.qml
#    qml/QtLocation/libdeclarative_location.so qml/QtLocation/plugins.qmltypes qml/QtLocation/qmldir
#    qml/QtMultimedia/libdeclarative_multimedia.so qml/QtMultimedia/plugins.qmltypes qml/QtMultimedia/qmldir qml/QtMultimedia/Video.qml
#    qml/QtNfc/libdeclarative_nfc.so qml/QtNfc/plugins.qmltypes qml/QtNfc/qmldir
#    qml/QtPositioning/libdeclarative_positioning.so qml/QtPositioning/plugins.qmltypes qml/QtPositioning/qmldir
#    qml/QtQml/Models.2/libmodelsplugin.so qml/QtQml/Models.2/plugins.qmltypes qml/QtQml/Models.2/qmldir qml/QtQml/StateMachine/libqtqmlstatemachine.so qml/QtQml/StateMachine/plugins.qmltypes qml/QtQml/StateMachine/qmldir

=== src/core/CMakeLists.txt ===
option(WITH_QT_PRIVATE_HEADERS "Use private Qt headers" OFF)

qt5_wrap_cpp(core_GEN_MOC_SRCS
  utils/debugutils.h
  config/batchimportsourcesmodel.h
  config/batchimportconfig.h
  config/filterconfig.h
  config/formatconfig.h
  config/generalconfig.h
  config/importconfig.h
  config/exportconfig.h
  config/tagconfig.h
  config/fileconfig.h
  config/rendirconfig.h
  config/numbertracksconfig.h
  config/useractionsconfig.h
  config/guiconfig.h
  config/networkconfig.h
  config/playlistconfig.h
  config/serverimporterconfig.h
  config/findreplaceconfig.h
  config/mainwindowconfig.h
  config/starratingmappingsmodel.h
  tags/frame.h
  tags/framenotice.h
  import/batchimporter.h
  import/httpclient.h
  import/importclient.h
  import/serverimporter.h
  import/servertrackimporter.h
  model/audioplayer.h
  model/commandstablemodel.h
  model/dirrenamer.h
  model/downloadclient.h
  model/externalprocess.h
  model/filefilter.h
  model/fileproxymodel.h
  model/fileproxymodeliterator.h
  model/bidirfileproxymodeliterator.h
  model/framelist.h
  model/frametablemodel.h
  model/kid3application.h
  model/trackdatamodel.h
  model/tagsearcher.h
  model/timeeventmodel.h
  model/taggedfileselection.h
  model/genremodel.h
  model/frameeditorobject.h
  model/frameobjectmodel.h
  model/mprisinterface.h
  model/playlistmodel.h
  model/proxyitemselectionmodel.h
  model/filesystemmodel.h
  model/fileinfogatherer_p.h
  TARGET kid3-core
)
if(HAVE_QTDBUS)
  qt5_wrap_cpp(qtdbus_GEN_MOC_SRCS
    model/scriptinterface.h
    TARGET kid3-core
  )
endif()
if(ANDROID)
  qt5_wrap_cpp(android_GEN_MOC_SRCS
    utils/androidutils.h
    TARGET kid3-core
  )
endif()

add_library(kid3-core
  utils/debugutils.cpp
  utils/saferename.cpp
  utils/loadtranslation.cpp
  utils/icoreplatformtools.cpp
  utils/coreplatformtools.cpp
  config/batchimportconfig.cpp
  config/batchimportprofile.cpp
  config/batchimportsourcesmodel.cpp
  config/configstore.cpp
  config/filterconfig.cpp
  config/formatconfig.cpp
  config/generalconfig.cpp
  config/importconfig.cpp
  config/exportconfig.cpp
  config/tagconfig.cpp
  config/fileconfig.cpp
  config/rendirconfig.cpp
  config/numbertracksconfig.cpp
  config/useractionsconfig.cpp
  config/guiconfig.cpp
  config/networkconfig.cpp
  config/playlistconfig.cpp
  config/serverimporterconfig.cpp
  config/isettings.cpp
  config/kid3settings.cpp
  config/findreplaceconfig.cpp
  config/mainwindowconfig.cpp
  config/starratingmappingsmodel.cpp
  tags/attributedata.cpp
  tags/genres.cpp
  tags/formatreplacer.cpp
  tags/frame.cpp
  tags/framenotice.cpp
  tags/pictureframe.cpp
  tags/taggedfile.cpp
  tags/itaggedfilefactory.cpp
  tags/trackdata.cpp
  export/playlistcreator.cpp
  export/textexporter.cpp
  import/batchimporter.cpp
  import/httpclient.cpp
  import/importclient.cpp
  import/importparser.cpp
  import/iserverimporterfactory.cpp
  import/iservertrackimporterfactory.cpp
  import/jsonparser.cpp
  import/serverimporter.cpp
  import/servertrackimporter.cpp
  import/textimporter.cpp
  import/trackdatamatcher.cpp
  model/iabortable.cpp
  model/audioplayer.cpp
  model/commandformatreplacer.cpp
  model/commandstablemodel.cpp
  model/configtablemodel.cpp
  model/dirproxymodel.cpp
  model/dirrenamer.cpp
  model/downloadclient.cpp
  model/expressionparser.cpp
  model/externalprocess.cpp
  model/filefilter.cpp
  model/fileproxymodel.cpp
  model/fileproxymodeliterator.cpp
  model/bidirfileproxymodeliterator.cpp
  model/framelist.cpp
  model/frametablemodel.cpp
  model/iframeeditor.cpp
  model/kid3application.cpp
  model/modeliterator.cpp
  model/taggedfileiconprovider.cpp
  model/texttablemodel.cpp
  model/trackdatamodel.cpp
  model/checkablestringlistmodel.cpp
  model/tagsearcher.cpp
  model/timeeventmodel.cpp
  model/eventtimingcode.cpp
  model/tracknumbervalidator.cpp
  model/taggedfileselection.cpp
  model/genremodel.cpp
  model/pixmapprovider.cpp
  model/frameeditorobject.cpp
  model/frameobjectmodel.cpp
  model/iusercommandprocessor.cpp
  model/mprisinterface.cpp
  model/playlistmodel.cpp
  model/proxyitemselectionmodel.cpp
  model/filesystemmodel.cpp
  model/fileinfogatherer.cpp
  model/abstractfiledecorationprovider.cpp
)
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE model/scriptinterface.cpp)
endif()
if(ANDROID)
  target_sources(kid3-core PRIVATE utils/androidutils.cpp)
endif()
target_sources(kid3-core PRIVATE ${core_GEN_MOC_SRCS})
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE ${qtdbus_GEN_MOC_SRCS})
endif()
if(ANDROID)
  target_sources(kid3-core PRIVATE ${android_GEN_MOC_SRCS})
endif()

target_include_directories(kid3-core PUBLIC utils config tags export import model)

target_compile_definitions(kid3-core
  PRIVATE KID3_BUILD_CORE_LIB
  PUBLIC QT_ASCII_CAST_WARNINGS QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_STRICT_ITERATORS QT_NO_EXCEPTIONS QT_NO_STL
)

set_target_properties(kid3-core PROPERTIES VERSION ${KID3_VERSION})
if(CMAKE_VERSION VERSION_GREATER "3.8")
  target_compile_features(kid3-core PUBLIC cxx_std_11)
else()
  target_compile_features(kid3-core PUBLIC cxx_auto_type cxx_nullptr cxx_override)
endif()
target_link_libraries(kid3-core PUBLIC Qt5::Core Qt5::Gui Qt5::Network Qt5::Xml Qt5::Multimedia)
if(WITH_QT_PRIVATE_HEADERS)
  target_compile_definitions(kid3-core PRIVATE USE_QT_PRIVATE_HEADERS)
  target_link_libraries(kid3-core PRIVATE Qt5::CorePrivate)
endif()
if(WITH_DBUS)
  target_link_libraries(kid3-core PUBLIC Qt5::DBus)
endif()
if(PLUGIN_LIBRARIES)
  target_link_libraries(kid3-core PUBLIC ${PLUGIN_LIBRARIES})
endif()
if(APPLE)
  target_link_libraries(kid3-core PUBLIC "-framework CoreServices")
endif()
if(ANDROID)
  target_link_libraries(kid3-core PUBLIC Qt5::AndroidExtras)
endif()

if(BUILD_SHARED_LIBS)
  install(TARGETS kid3-core
    LIBRARY DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif()

if(BUILD_KDE_APP)
  install(FILES model/net.sourceforge.Kid3.xml
          DESTINATION ${WITH_DBUSDIR})
endif()

=== debian/changelog ===
kid3 (3.7.1-3) unstable; urgency=medium

  * Make a new source only upload.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 24 Jul 2019 15:21:35 +0200

kid3 (3.7.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.4.0.
  * Uploading to unstable.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 09 Jul 2019 09:44:25 +0200

kid3 (3.7.1-1) experimental; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 25 Mar 2019 10:45:51 +0100

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 11),
 extra-cmake-modules,
 libkf5kio-dev,
 libkf5doctools-dev,
 qtmultimedia5-dev,
 qtdeclarative5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtdeclarative5-dev-tools,
 qml-module-qtquick2,
 cmake,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-xsl,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 4.4.0
Homepage: http://kid3.sourceforge.net/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains common libraries and data used by both kid3 and kid3-qt.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE audio tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains a command line interface for Kid3, for a GUI you can
 use kid3-qt or kid3.
